<?xml version="1.0" encoding="iso-8859-1"?>
<!DOCTYPE html 
     PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
     "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">

<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="en" lang="en">
<head>
  <title>Class: Development</title>
  <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1" />
  <meta http-equiv="Content-Script-Type" content="text/javascript" />
  <link rel="stylesheet" href=".././rdoc-style.css" type="text/css" media="screen" />
  <script type="text/javascript">
  // <![CDATA[

  function popupCode( url ) {
    window.open(url, "Code", "resizable=yes,scrollbars=yes,toolbar=no,status=no,height=150,width=400")
  }

  function toggleCode( id ) {
    if ( document.getElementById )
      elem = document.getElementById( id );
    else if ( document.all )
      elem = eval( "document.all." + id );
    else
      return false;

    elemStyle = elem.style;
    
    if ( elemStyle.display != "block" ) {
      elemStyle.display = "block"
    } else {
      elemStyle.display = "none"
    }

    return true;
  }
  
  // Make codeblocks hidden by default
  document.writeln( "<style type=\"text/css\">div.method-source-code { display: none }</style>" )
  
  // ]]>
  </script>

</head>
<body>



    <div id="classHeader">
        <table class="header-table">
        <tr class="top-aligned-row">
          <td><strong>Class</strong></td>
          <td class="class-name-in-header">Development</td>
        </tr>
        <tr class="top-aligned-row">
            <td><strong>In:</strong></td>
            <td>
                <a href="../files/app/models/development_rb.html">
                app/models/development.rb
                </a>
        <br />
            </td>
        </tr>

        <tr class="top-aligned-row">
            <td><strong>Parent:</strong></td>
            <td>
                Object
            </td>
        </tr>
        </table>
    </div>
  <!-- banner header -->

  <div id="bodyContent">



  <div id="contextContent">



   </div>

    <div id="method-list">
      <h3 class="section-bar">Methods</h3>

      <div class="name-list">
      <a href="#M000084">commits_per_dir</a>&nbsp;&nbsp;
      <a href="#M000083">last_10_commits</a>&nbsp;&nbsp;
      <a href="#M000082">new</a>&nbsp;&nbsp;
      <a href="#M000088">owner</a>&nbsp;&nbsp;
      <a href="#M000085">rails_log</a>&nbsp;&nbsp;
      <a href="#M000086">rails_log_all</a>&nbsp;&nbsp;
      <a href="#M000087">revision</a>&nbsp;&nbsp;
      </div>
    </div>

  </div>


    <!-- if includes -->
    <div id="includes">
      <h3 class="section-bar">Included Modules</h3>

      <div id="includes-list">
        <span class="include-name">Reloadable</span>
      </div>
    </div>

    <div id="section">


    <div id="constants-list">
      <h3 class="section-bar">Constants</h3>

      <div class="name-list">
        <table summary="Constants">
        <tr class="top-aligned-row context-row">
          <td class="context-item-name">Long_SVN_line</td>
          <td>=</td>
          <td class="context-item-value">&quot;------------------------------------&quot; &lt;&lt;     &quot;------------------------------------\n&quot;</td>
        </tr>
        </table>
      </div>
    </div>



      


    <!-- if method_list -->
    <div id="methods">
      <h3 class="section-bar">Public Class methods</h3>

      <div id="method-M000082" class="method-detail">
        <a name="M000082"></a>

        <div class="method-heading">
          <a href="#M000082" class="method-signature">
          <span class="method-name">new</span><span class="method-args">()</span>
          </a>
        </div>
      
        <div class="method-description">
          <p><a class="source-toggle" href="#"
            onclick="toggleCode('M000082-source');return false;">[Source]</a></p>
          <div class="method-source-code" id="M000082-source">
<pre>
    <span class="ruby-comment cmt"># File app/models/development.rb, line 8</span>
 8:   <span class="ruby-keyword kw">def</span> <span class="ruby-identifier">initialize</span> 
 9:     <span class="ruby-ivar">@raw_log</span> = <span class="ruby-value">`svn log \
10:        --non-interactive --verbose \
11:        http://svn.devjavu.com/mwamko/branches/presentation/presentation`</span>.<span class="ruby-identifier">split</span>(<span class="ruby-constant">Long_SVN_line</span>)
12:   <span class="ruby-keyword kw">end</span>
</pre>
          </div>
        </div>
      </div>

      <div id="method-M000088" class="method-detail">
        <a name="M000088"></a>

        <div class="method-heading">
          <a href="#M000088" class="method-signature">
          <span class="method-name">owner</span><span class="method-args">()</span>
          </a>
        </div>
      
        <div class="method-description">
          <p><a class="source-toggle" href="#"
            onclick="toggleCode('M000088-source');return false;">[Source]</a></p>
          <div class="method-source-code" id="M000088-source">
<pre>
    <span class="ruby-comment cmt"># File app/models/development.rb, line 59</span>
59:   <span class="ruby-keyword kw">def</span> <span class="ruby-keyword kw">self</span>.<span class="ruby-identifier">owner</span>
60:     <span class="ruby-value">`pwd`</span>.<span class="ruby-identifier">chomp</span>
61:   <span class="ruby-keyword kw">end</span>
</pre>
          </div>
        </div>
      </div>

      <div id="method-M000087" class="method-detail">
        <a name="M000087"></a>

        <div class="method-heading">
          <a href="#M000087" class="method-signature">
          <span class="method-name">revision</span><span class="method-args">()</span>
          </a>
        </div>
      
        <div class="method-description">
          <p><a class="source-toggle" href="#"
            onclick="toggleCode('M000087-source');return false;">[Source]</a></p>
          <div class="method-source-code" id="M000087-source">
<pre>
    <span class="ruby-comment cmt"># File app/models/development.rb, line 55</span>
55:   <span class="ruby-keyword kw">def</span> <span class="ruby-keyword kw">self</span>.<span class="ruby-identifier">revision</span>
56:     <span class="ruby-value">`svn info --non-interactive`</span>.<span class="ruby-identifier">match</span>(<span class="ruby-regexp re">/Revision: (.*?)\n/</span>)[<span class="ruby-value">1</span>].<span class="ruby-identifier">to_i</span>
57:   <span class="ruby-keyword kw">end</span>
</pre>
          </div>
        </div>
      </div>

      <h3 class="section-bar">Public Instance methods</h3>

      <div id="method-M000084" class="method-detail">
        <a name="M000084"></a>

        <div class="method-heading">
          <a href="#M000084" class="method-signature">
          <span class="method-name">commits_per_dir</span><span class="method-args">()</span>
          </a>
        </div>
      
        <div class="method-description">
          <p><a class="source-toggle" href="#"
            onclick="toggleCode('M000084-source');return false;">[Source]</a></p>
          <div class="method-source-code" id="M000084-source">
<pre>
    <span class="ruby-comment cmt"># File app/models/development.rb, line 18</span>
18:   <span class="ruby-keyword kw">def</span> <span class="ruby-identifier">commits_per_dir</span>
19:     <span class="ruby-identifier">commits_per_dir</span> = {}
20: 
21:     [<span class="ruby-value str">'trunk'</span>,
22:      <span class="ruby-value str">'trunk/db'</span>,
23:      <span class="ruby-value str">'trunk/app/models'</span>,
24:      <span class="ruby-value str">'trunk/app/controllers'</span>,
25:      <span class="ruby-value str">'trunk/app/views'</span>
26:     ].<span class="ruby-identifier">each</span> <span class="ruby-keyword kw">do</span> <span class="ruby-operator">|</span><span class="ruby-identifier">dir</span><span class="ruby-operator">|</span>
27:       <span class="ruby-identifier">counts</span> = {}
28:       <span class="ruby-identifier">counts</span>.<span class="ruby-identifier">default</span> = <span class="ruby-value">0</span>
29: 
30:       <span class="ruby-ivar">@raw_log</span>.<span class="ruby-identifier">each</span> <span class="ruby-keyword kw">do</span> <span class="ruby-operator">|</span><span class="ruby-identifier">one_revision</span><span class="ruby-operator">|</span>
31:         <span class="ruby-identifier">author</span> = <span class="ruby-identifier">one_revision</span>.<span class="ruby-identifier">scan</span>(<span class="ruby-regexp re">/r.*? \| (.+?) \| /</span>)[<span class="ruby-value">0</span>].<span class="ruby-identifier">to_s</span> 
32:         <span class="ruby-keyword kw">if</span> <span class="ruby-identifier">one_revision</span>.<span class="ruby-identifier">scan</span>(<span class="ruby-node">/ . . \/#{dir}/</span>) <span class="ruby-operator">!=</span> []
33:           <span class="ruby-identifier">counts</span>[<span class="ruby-identifier">author</span>] =  <span class="ruby-identifier">counts</span>[<span class="ruby-identifier">author</span>] <span class="ruby-operator">+</span> <span class="ruby-value">1</span> <span class="ruby-keyword kw">unless</span> <span class="ruby-identifier">author</span> <span class="ruby-operator">==</span> <span class="ruby-value str">''</span>
34:         <span class="ruby-keyword kw">end</span>
35:       <span class="ruby-keyword kw">end</span>
36: 
37:       <span class="ruby-identifier">commits_per_dir</span>[<span class="ruby-identifier">dir</span>] = <span class="ruby-value str">''</span>
38:       <span class="ruby-identifier">counts</span>.<span class="ruby-identifier">sort</span>{<span class="ruby-operator">|</span><span class="ruby-identifier">a</span>,<span class="ruby-identifier">b</span><span class="ruby-operator">|</span> <span class="ruby-identifier">b</span>[<span class="ruby-value">1</span>]<span class="ruby-operator">&lt;=&gt;</span><span class="ruby-identifier">a</span>[<span class="ruby-value">1</span>]}.<span class="ruby-identifier">each</span> <span class="ruby-keyword kw">do</span> <span class="ruby-operator">|</span><span class="ruby-identifier">author</span>, <span class="ruby-identifier">count</span><span class="ruby-operator">|</span>
39:         <span class="ruby-identifier">commits_per_dir</span>[<span class="ruby-identifier">dir</span>] <span class="ruby-operator">&lt;&lt;</span> <span class="ruby-identifier">author</span>.<span class="ruby-identifier">ljust</span>(<span class="ruby-value">16</span>) <span class="ruby-operator">&lt;&lt;</span> <span class="ruby-identifier">count</span>.<span class="ruby-identifier">to_s</span> <span class="ruby-operator">&lt;&lt;</span> <span class="ruby-value str">&quot;\n&quot;</span>
40:       <span class="ruby-keyword kw">end</span>
41:     <span class="ruby-keyword kw">end</span>
42: 
43:     <span class="ruby-keyword kw">return</span> <span class="ruby-identifier">commits_per_dir</span>
44:   <span class="ruby-keyword kw">end</span>
</pre>
          </div>
        </div>
      </div>

      <div id="method-M000083" class="method-detail">
        <a name="M000083"></a>

        <div class="method-heading">
          <a href="#M000083" class="method-signature">
          <span class="method-name">last_10_commits</span><span class="method-args">()</span>
          </a>
        </div>
      
        <div class="method-description">
          <p><a class="source-toggle" href="#"
            onclick="toggleCode('M000083-source');return false;">[Source]</a></p>
          <div class="method-source-code" id="M000083-source">
<pre>
    <span class="ruby-comment cmt"># File app/models/development.rb, line 14</span>
14:   <span class="ruby-keyword kw">def</span> <span class="ruby-identifier">last_10_commits</span>
15:     <span class="ruby-ivar">@raw_log</span>.<span class="ruby-identifier">first</span>(<span class="ruby-value">10</span>).<span class="ruby-identifier">join</span>(<span class="ruby-constant">Long_SVN_line</span>)
16:   <span class="ruby-keyword kw">end</span>
</pre>
          </div>
        </div>
      </div>

      <div id="method-M000085" class="method-detail">
        <a name="M000085"></a>

        <div class="method-heading">
          <a href="#M000085" class="method-signature">
          <span class="method-name">rails_log</span><span class="method-args">()</span>
          </a>
        </div>
      
        <div class="method-description">
          <p><a class="source-toggle" href="#"
            onclick="toggleCode('M000085-source');return false;">[Source]</a></p>
          <div class="method-source-code" id="M000085-source">
<pre>
    <span class="ruby-comment cmt"># File app/models/development.rb, line 46</span>
46:   <span class="ruby-keyword kw">def</span> <span class="ruby-identifier">rails_log</span>
47:     <span class="ruby-value">`tail -n 100 log/development.log`</span>
48:   <span class="ruby-keyword kw">end</span>
</pre>
          </div>
        </div>
      </div>

      <div id="method-M000086" class="method-detail">
        <a name="M000086"></a>

        <div class="method-heading">
          <a href="#M000086" class="method-signature">
          <span class="method-name">rails_log_all</span><span class="method-args">()</span>
          </a>
        </div>
      
        <div class="method-description">
          <p><a class="source-toggle" href="#"
            onclick="toggleCode('M000086-source');return false;">[Source]</a></p>
          <div class="method-source-code" id="M000086-source">
<pre>
    <span class="ruby-comment cmt"># File app/models/development.rb, line 50</span>
50:   <span class="ruby-keyword kw">def</span> <span class="ruby-identifier">rails_log_all</span>
51:     <span class="ruby-value">`cat log/development.log`</span>
52:   <span class="ruby-keyword kw">end</span>
</pre>
          </div>
        </div>
      </div>


    </div>


  </div>


<div id="validator-badges">
  <p><small><a href="http://validator.w3.org/check/referer">[Validate]</a></small></p>
</div>

</body>
</html>